#ifndef __EXPORCDCATDB_H__
#define __EXPORCDCATDB_H__
/****************************************************************************
                             Hyper's CD Catalog
		A multiplatform qt and xml based catalog program
 
 Author    : Christoph Thielecke (crissi99@gmx.de)
 License   : GPL
 Copyright : (C) 2003 Christoph Thielecke
****************************************************************************/

#include <qvariant.h>
#include <qpixmap.h>
#include <qdialog.h>
#include <qdatetime.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include <qobject.h>
#include <qlistview.h>
#include <qfiledialog.h>
#include <qwidget.h>
#include <qdatetime.h>
#include <qlist.h>
#include <qdialog.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <qvariant.h>
#include <qpixmap.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlineedit.h>
#include <qdialog.h>
#include <qlabel.h>
#include <stdio.h>
#include <ctype.h>
#include <qfile.h>
#include <qabstractlayout.h>

#include <expat.h>
#include "recode.h"

#include "guibase.h"
#include "dbase.h"
#include "wdbfile.h"


class QLabel;
class QLineEdit;
class QPushButton;

class exportCdcatDB : public QDialog
{
	Q_OBJECT

public:
	exportCdcatDB(DataBase *db,QWidget* parent=0, const char* name=0, bool modal=true, WFlags fl=0 );
	~exportCdcatDB();


	void fillMedia();
	QLabel* textLabel2;
	QListBox* allMedia;
	QPushButton* buttonRemove;
	QPushButton* buttonAdd;
	QLabel* textLabel2_2;
	QListBox* selectedMedia;
	QCheckBox* checkAllMedia;
	QButtonGroup* buttonGroup1;
	QRadioButton* radioHtml;
	QRadioButton* radioCsv;
	QLabel* textLabel1;
	QLabel* textLabel3;
	QLineEdit* separatorInput;
	QLineEdit* fileName;
	QPushButton* buttonFile;
	QPushButton* buttonOk;
	QPushButton* buttonCancel;
	int OK;


protected:
	QGridLayout* exportCdcatDBLayout;
	QVBoxLayout* layout32;
	QHBoxLayout* layout21;
	QVBoxLayout* layout10_2;
	QVBoxLayout* layout19;
	QHBoxLayout* layout10;
	QVBoxLayout* layout10_2_2;
	QGridLayout* buttonGroup1Layout;
	QVBoxLayout* layout26;
	QHBoxLayout* layout25;
	QHBoxLayout* layout29;
	QHBoxLayout* layout4;
	DataBase *p;
	QString separator;
	QFile f;
	int writeDown(Node *source);
	int  writeCatalog  (Node *source);
	int  writeMedia    (Node *source);
	int  writeDirectory(Node *source);
	int  writeFile     (Node *source);
	int  writeMp3Tag   (Node *source);
	void commentWriter (char *c);
	QString getFilePath(Node *current);



protected slots:
	virtual void languageChange();
	bool doHtmlExport();
	bool doCsvExport();
public slots:
	virtual void addMedia();
	virtual void ok();
	virtual void cancel();
	virtual void removeMedia();
	virtual void allMediaToggled();
	virtual void browseFile();

private:
	QString outstring;
	QString medianame;
	QString currentpath;
	char *out1;
	char *out2;
	char *out3;
	char *out4;
	char *out5;
};

#endif
