/****************************************************************************
                             Hyper's CD Catalog
		A multiplatform qt and xml based catalog program
  
 Author    : Peter Deak (hyperr@freemail.hu)
 License   : GPL
 Copyright : (C) 2003 Peter Deak
****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <qfile.h>
#include <qtextstream.h>

#ifdef _WIN32
#include <windows.h>
#endif


#ifndef _WIN32 
//Linux:
char *getCDName(const char *CDpath)
 {
   char *name       = new char[64]; //return value
   char *devicename = new char[64];
   FILE *deviceptr  = NULL;

   strcpy(devicename,"");
   strcpy(name      ,"");


   QFile f("/etc/fstab");
   QString line;


   if (f.open(IO_ReadOnly)) 
    {	// file opened successfully
     QTextStream t(&f);	// use a text stream
     while (!t.eof()) 
       {
         line = t.readLine();	// line of text excluding '\n'
         if(!line.startsWith("#")) // not a commented line
	   {
             if((line.section("\t",1,1)).compare(CDpath) == 0) 
	        strcpy(devicename,(const char *)line.section("\t",0,0));
	     if((line.section(" " ,1,1)).compare(CDpath) == 0) 
	        strcpy(devicename,(const char *)line.section(" " ,0,0));	       
           } 
       }
     f.close();
    }
   else 
      return name; 
   if (!strcmp(devicename,"")) 
      return name;
       
   //fprintf(stderr,"devicename: |%s|\n",devicename);

  /** Read the volume name of the device *******************/

   deviceptr=fopen(devicename,"r");
   if(deviceptr==NULL)
      return name;
   fseek(deviceptr,32808,SEEK_SET);
   fread(name,sizeof(char),32,deviceptr);
   fclose(deviceptr);
   name[32]='\0'; 
   
   //strip whitespaces
   strcpy(name,(const char *)QString(name).stripWhiteSpace());  
   delete devicename;
   return name;
 }

#else
// Win32:
char * getCDName(const char *CDpath) 
 {
  char  *name = new char[64];
  DWORD  dwDummy;
  DWORD  dwFlags;

  if(!GetVolumeInformation((LPCSTR)CDpath,(LPSTR)name,64,NULL,
                            &dwDummy,&dwFlags,NULL,0))
      strcpy(name,"");
  return name;
 }
#endif

